#ifndef __GONNIES_MAP
#define __GONNIES_MAP


class GMapTilePlace {
public:
	GMapTile *m_tile;
	int m_x,m_y;
};


class GObjectPlace {
public:
	
	GObjectPlace(void) {m_name=0;};
	~GObjectPlace(void) {
		if (m_name!=0) delete m_name;
		m_name=0;
	}

	char *m_name;
	int m_x,m_y;
	List<int> m_parameters;
};



class GMapLayer {
public:
	GMapLayer();
	GMapLayer(FILE *fp,List<GMapTile> *tiles);
	~GMapLayer();

	void save(FILE *fp);

	void draw(int dx,int dy);

	void clear(void);

	void add_tile(int x,int y,GMapTile *tile);
	void add_object(int x,int y,char *name);
	bool delete_tile(int x,int y);
	
	void delete_object(GObjectPlace *o);
	GObjectPlace *get_object(int x,int y);

private:
	List<GMapTilePlace> m_tiles;
	List<GObjectPlace> m_objects;
};


class GMap {
public:
	GMap(int dx,int dy);
	GMap(FILE *fp,List<GMapTile> *tiles);
	~GMap();

	void save(FILE *fp);

	void draw(int dx,int dy);
	void draw(int dx,int dy,int layer);

	int get_dx(void) {return m_dx;};
	int get_dy(void) {return m_dy;};
	int get_n_layers(void) {return m_layers.Length();};

	void delete_layer(int layer);
	void clear_layer(int layer);
	void add_layer(void);

	void add_tile(int layer,int x,int y,GMapTile *tile);
	void add_object(int layer,int x,int y,char *name);
	bool delete_tile(int x,int y);
	bool delete_tile(int layer,int x,int y);
	
	void delete_object(GObjectPlace *o);

	GObjectPlace *get_object(int x,int y);
	GObjectPlace *get_object(int layer,int x,int y);

	static GMapTile *object_tile(char *name,List<int> *parameters);

	void set_scripts(char *text);
	char *get_scripts(void) {return m_scripts;};

private:
	int m_dx,m_dy;
	List<GMapLayer> m_layers;
	char *m_scripts;

};

#endif

